﻿using NHibernate;
using NHibernateTest.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using NHibernate.Linq;

namespace NHibernateTest.Controllers
{
	public class EmployeeController : Controller
	{
		//
		// GET: /Employee/
		public ActionResult Index()
		{
			using (ISession session = NHibertnateSession.OpenSession())
			{
				var employees = session.Query<Employee>().ToList();
				return View(employees);
			}
		}

		public ActionResult Create()
		{
			return View();
		}


		[HttpPost]
		public ActionResult Create(Employee emplolyee)
		{
			try
			{
				using (ISession session = NHibertnateSession.OpenSession())
				{
					using (ITransaction transaction = session.BeginTransaction())
					{
						session.Save(emplolyee);
						transaction.Commit();
					}
				}

				return RedirectToAction("Index");
			}
			catch (Exception exception)
			{
				return View();
			}
		}

		public ActionResult Edit(int id)
		{
			using (ISession session = NHibertnateSession.OpenSession())
			{
				var employee = session.Get<Employee>(id);
				return View(employee);
			}

		}


		[HttpPost]
		public ActionResult Edit(int id, Employee employee)
		{
			try
			{
				using (ISession session = NHibertnateSession.OpenSession())
				{
					var employeetoUpdate = session.Get<Employee>(id);

					employeetoUpdate.Designation = employee.Designation;
					employeetoUpdate.FirstName = employee.FirstName;
					employeetoUpdate.LastName = employee.LastName;

					using (ITransaction transaction = session.BeginTransaction())
					{
						session.Save(employeetoUpdate);
						transaction.Commit();
					}
				}
				return RedirectToAction("Index");
			}
			catch
			{
				return View();
			}
		}

		public ActionResult Details(int id)
		{
			using (ISession session = NHibertnateSession.OpenSession())
			{
				var employee = session.Get<Employee>(id);
				return View(employee);
			}
		}

		public ActionResult Delete(int id)
		{
			using (ISession session = NHibertnateSession.OpenSession())
			{
				var employee = session.Get<Employee>(id);
				return View(employee);
			}
		}


		[HttpPost]
		public ActionResult Delete(int id, Employee employee)
		{
			try
			{
				using (ISession session = NHibertnateSession.OpenSession())
				{
					using (ITransaction transaction = session.BeginTransaction())
					{
						session.Delete(employee);
						transaction.Commit();
					}
				}
				return RedirectToAction("Index");
			}
			catch (Exception exception)
			{
				return View();
			}
		}
	}
}